/*****************************************************************************
|*
|*  VERSION CONTROL:    @(#)main.c	1.1 98/06/19
|*
|*  IN PACKAGE:         AX/HX93X Firmware
|*
|*  COPYRIGHT:          Copyright (c) 1998 Tasking Software B.V.
|*
|*  DESCRIPTION:
|*	
|*	Universal serial bus 93XHX/AX hub/function startup and main loop
|*
 ****************************************************************************/

#include "usb.h"
#include "eval.h"
#include "hub.h"
#include "function.h"

static void heart_beat	( void );

/*****************************************************************************
|*
|*  FUNCTION:           main
|*
|*  AVAILABILITY:	external
|*
|*  PARAMETERS:
|*
|*  RETURN VALUE:
|*
|*  DESCRIPTION:
|*
|*	Initialize the Hub/Function
|*
 */
void main( void )
{
	LED_PORT = 0x00;  	/* turn LED's off */
#if defined( _REG931HX_SFR ) || defined( _REG931AX_SFR )
	SET_KSEN;
#endif
	/*
         * Enable hub interrupts
         * Enable resume interrupt
	 */

#if defined( _REG930AX_SFR ) || defined( _REG931AX_SFR )
	initialize_function();
#else
	initialize_hub();
#endif

	EA = 1;			/* enable interrupts */


	heart_beat();
}

/*****************************************************************************
|*
|*  FUNCTION:           heart_beat
|*
|*  AVAILABILITY:	static
|*
|*  PARAMETERS:
|*
|*  RETURN VALUE:
|*
|*  DESCRIPTION:
|*
|*	This routine simply sets and clears HEARTBEAT_LED at a periodic rate. 
|*	Its purpose is to let the user know the board is alive.
|*
 */
static void heart_beat( void )
{
	unsigned int	heart;

	while ( 1 )
	{

		/*
		 * generate a heart beat
		 */
		heart++;
	
		if ( (heart & 0x7FFF ) == 0x0000 )
		{
			HEARTBEAT_LED ^= 1;	/* toggle led */
		}
	}
}
